//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****     KTime - AVRIL 2005 - CopyRight  XCS Corporation		*****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                (enfin...)        *****
//***************************************************************************
//***************************************************************************

#include "KTime.h"

int             KTime  [256];
float           tact;

TypeK           K;
TFenetreGL      F;
TSouris         Souris;


//*****************************************************************************
//***  TypeK  *****************************************************************
//*****************************************************************************
float TypeK::Clock()
{
	LARGE_INTEGER TIMERs;
	QueryPerformanceCounter(&TIMERs);CountAct=TIMERs.QuadPart;
	float Time=(float)(    (   (CountAct-CountIni)*1000   /CountPerSecond   )   );
	return(Time);
}
//*****************************************************
void TypeK::InitFPS()
{
	LARGE_INTEGER CountPerSeconde;
	QueryPerformanceFrequency(&CountPerSeconde);CountPerSecond=CountPerSeconde.QuadPart;
	QueryPerformanceCounter  (&CountPerSeconde);CountIni      =CountPerSeconde.QuadPart;
        fps=30;
	tact=0;
	dtime=0.03f;
	t1=0;	frame=0;oldtact=Clock()-50;
}
//*****************************************************
void TypeK::RefreshFPS()
{
	oldtact=tact;
	tact=Clock();
	/////////////////// fps
	frame++;
	t2=Clock();
	if( (t2-t1)>=1000 )
	{
		fps=(float)frame/( (float)(tact-t1)/1000  );
		t1=Clock();
		frame=0;
	}
	/////////////////// dtime
	dtime=(tact-oldtact)/1000;
	if (dtime<=0)   dtime=0.01f;
	if (dtime>=0.1) dtime=0.1f;

}
//*****************************************************
void TypeK::ShowMessage(LPTSTR lpszFunction) // Retrieve the system error message for the last-error code
{
    char *  lpMsgBuf;
    //LPVOID lpDisplayBuf;
    DWORD dw = GetLastError();
    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),(LPTSTR) &lpMsgBuf, 0, NULL );
   // ExitProcess(dw);
}
//****************************************************************************************************************
void TypeK::InitKTime()
{
	FillChar (KTime ,sizeof(KTime ),0);
	FillChar (KTime2,sizeof(KTime2),0);
        GetKeyboardState((unsigned char *)&Keys);
	memcpy(OldKeys,Keys,sizeof(Keys));
}
//****************************************************************************************************************
void TypeK::RefreshKTime ()
{
	//****************** NECESSITE INIT OLDKEYS !!!!!!!!!!!!!!!!!!!!!!!
        GetKeyboardState((unsigned char *)&Keys);
	for (int k=0;k<256;k++)
	{
		if  (Keys[k]<0) {KTime[k]++;KTime2[k]++;} else {
			if (ABS(OldKeys[k]-Keys[k]%2)==1)
					{KTime[k]=1;KTime2[k]=1;}
			else	{KTime[k]=0;KTime2[k]=0;}
		}
		OldKeys[k]=Keys[k];
	}
	if (KTime[33]>0) FaCt01+=0.005f;
	if (KTime[34]>0) FaCt01-=0.005f;

	if (KTime[36]>0) fAcT01+=0.005f;
	if (KTime[35]>0) fAcT01-=0.005f;
}
//****************************************************************************************************************
bool TypeK::KeyPressed()
{
	int k;
	bool key=false;
        for (k=0;k<255;k++) key=key||(KTime[k]>0);
	return(key);
}
//****************************************************************************************************************
int TypeK::KeyPressed1(bool SaufCtShAl)
{
	int k;
        if (SaufCtShAl) { for (k=0;k<256;k++) if ( (k!=16)&&(k!=17)&&(k!=18)&&(k!=160)&&(k!=161)&&(k!=162)&&(k!=163)&&(k!=164)&&(k!=165)&&(KTime[k]==1)) return(k); }
                   else { for (k=0;k<256;k++) if (KTime[k]==1) return(k);}
        return(0);
}


//*****************************************************************************
//** TFenetreGL ***************************************************************
//*****************************************************************************


LRESULT CALLBACK WndProc(HWND	hWnd, UINT   uMsg, WPARAM	wParam,	LPARAM	lParam)
{
        int TX,TY;
        switch (uMsg)
	{
                case WM_SIZE    : TX =LOWORD(lParam); TY = HIWORD(lParam);
                                  F.Width=TX; F.Height=TY;glViewport(0,0,TX,TY);break;

                case WM_CLOSE   : exit(0);// BAAAM !
                case WM_MOUSEMOVE:
                {       int x=(short)LOWORD(lParam); int y=(short)HIWORD(lParam);
                        Souris.OnMove(x,y);
                        break;
                }
                case WM_LBUTTONDOWN  : Souris.ButtonL=true;  break;
                case WM_LBUTTONUP    : Souris.ButtonL=false; break;
                case WM_RBUTTONDOWN  : Souris.ButtonR=true;  break;
                case WM_RBUTTONUP    : Souris.ButtonR=false; break;
                case WM_MBUTTONDOWN  : Souris.ButtonM=true;  break;
                case WM_MBUTTONUP    : Souris.ButtonM=false; break;
                case WM_MOUSEWHEEL   : Souris.zDelta+=GET_WHEEL_DELTA_WPARAM(wParam); break; // WHEEL_DELTA = 120 = 1 cran
        }
        return DefWindowProc(hWnd,uMsg,wParam,lParam);
}
//*****************************************************
void TFenetreGL::InitFenetre(char * title, int width, int height, int bits32, bool fullscreenflag)
{
	GLuint		PixelFormat;		// Holds The Results After Searching For A Match
	WNDCLASS	wc;			// Windows Class Structure
	DWORD		dwExStyle;		// Window Extended Style
	DWORD		dwStyle;		// Window Style
	RECT		WindowRect;		// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;		// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;			// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);	       	// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;		        	// WndProc Handles Messages
	wc.cbClsExtra		= 0;			       			// No Extra Window Data
	wc.cbWndExtra		= 0;		   				// No Extra Window Data
	wc.hInstance		= hInstance;	        			// Set The Instance
	wc.hIcon		= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor		= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;					       	// No Background Required For GL
	wc.lpszMenuName		= NULL;					       	// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";				       	// Set The Class Name

	if (!RegisterClass(&wc))					       	// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return;
	}

	if (fullscreen)
	{
		DEVMODE dmScreenSettings;				// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);	// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;		// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;		// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits32;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL) fullscreen=FALSE;
	}

	if (fullscreen)								// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;					// Window Extended Style
		dwStyle=WS_POPUP;						// Windows Style
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;					// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size
	hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
        							"OpenGL",				// Class Name
								title,					// Window Title
								dwStyle |				// Defined Window Style
								WS_CLIPSIBLINGS |			// Required Window Style
								WS_CLIPCHILDREN,			// Required Window Style
								0, 0,					// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,					// No Parent Window
								NULL,					// No Menu
								hInstance,				// Instance
								NULL);
	if (!hWnd) {
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return;
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		32,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};

        hdc=GetDC(hWnd);
        PixelFormat=ChoosePixelFormat(hdc,&pfd);
        SetPixelFormat(hdc,PixelFormat,&pfd);
        hrc = wglCreateContext(hdc);
        Width=width; Height=height;

        Activate();
	ShowWindow(hWnd,SW_SHOW);	      		// Show The Window
	SetForegroundWindow(hWnd);	      		// Slightly Higher Priority
	SetFocus(hWnd);			      		// Sets Keyboard Focus To The Window
//	Re SizeGLScene(width, height);	      		// Set Up Our Perspective GL Screen
}
//*********************************************************************
void TFenetreGL::Resize(int PosX, int PosY, int TX, int TY)
{
        // BOOL WINAPI GetWindowPlacement( __in     HWND hWnd,  __inout  WINDOWPLACEMENT *lpwndpl); Si tu veux rcuprer la position d'une fentre... !!
        bool succ = MoveWindow( hWnd, PosX,PosY, TX,TY, true);
        if (!succ) glSortirProprement("GetProcessId");
        Width=TX; Height=TY;glViewport(0,0,tx(),ty());
}
//*********************************************************************
void TFenetreGL::SetCaption(bool ON)
{
            LONG nOldStyle = GetWindowLong(F.hWnd, GWL_STYLE);
            LONG nNewStyle;
            if (!ON)  nNewStyle =  nOldStyle & ~WS_CAPTION & ~WS_BORDER & ~WS_THICKFRAME;
                else  nNewStyle =  nOldStyle |  WS_CAPTION |  WS_BORDER |  WS_THICKFRAME;

            SetWindowLong(F.hWnd, GWL_STYLE, nNewStyle); /// on enlve la barre bleue !!! Ohhh !! Combien joliiii !!!
            SetWindowPos (F.hWnd,0, 0, 0, F.Width, F.Height, SWP_NOZORDER|SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE| SWP_DRAWFRAME); // On remet la barre bleue !!!
}
//*********************************************************************
void TFenetreGL::SetFullScreen(bool ON,int TX0,int TY0)
{
        DEVMODE dmScreenSettings;
        memset(&dmScreenSettings,0,sizeof(dmScreenSettings));
        dmScreenSettings.dmSize   =sizeof(dmScreenSettings);
        if (ON)
        {
            //--- 1 --- Grande fentre qui remplit tout l'cran
            SizeBeforeFullScr.x = F.tx();
            SizeBeforeFullScr.y = F.ty();
            SetCaption(false);
            if (TX0==0) TX0=GetSystemMetrics(SM_CXSCREEN);
            if (TY0==0) TY0=GetSystemMetrics(SM_CYSCREEN);
            Resize(0,0,TX0,TY0);
            //--- 2 --- La rsolution de l'cran : FullScreen
            dmScreenSettings.dmPelsWidth	  = TX0;
            dmScreenSettings.dmPelsHeight	  = TY0;
            dmScreenSettings.dmFields             = DM_PELSWIDTH|DM_PELSHEIGHT;
            int res = ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN);
            if (res == DISP_CHANGE_SUCCESSFUL) fullscreen=true;
        }
        else
        {
            SetCaption(true);
            dmScreenSettings.dmPelsWidth	  = (TX0 ? TX0 : F.EcranIni.x );
            dmScreenSettings.dmPelsHeight	  = (TX0 ? TX0 : F.EcranIni.y ); // on remet la rsolution initiale
            dmScreenSettings.dmFields             = DM_PELSWIDTH|DM_PELSHEIGHT;
            int res = ChangeDisplaySettings(&dmScreenSettings,0);
            if (res == DISP_CHANGE_SUCCESSFUL) fullscreen=false;
            Resize(0,0,SizeBeforeFullScr.x,SizeBeforeFullScr.y);
        }
}
//*********************************************************************
void TFenetreGL::DrawEssai()
{
        glMatrixMode(GL_MODELVIEW); glLoadIdentity();
        glMatrixMode(GL_PROJECTION);glLoadIdentity();gluOrtho2D(0,tx(),ty(),0);
        glViewport(0,0,tx(),ty()); // glViewport(0,ty(),tx(),ty()); peut mieux marcher parfois.

        glPixelStorei   (GL_UNPACK_ALIGNMENT,1);
        glEnable	(GL_LINE_SMOOTH);
        glHint	        (GL_LINE_SMOOTH_HINT,GL_NICEST);
        glTexEnvi	(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
        glTexParameteri	(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
        glTexParameteri	(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
        glShadeModel	(GL_FLAT);
        glEnable        (GL_DEPTH_TEST);
        glDisable	(GL_TEXTURE_2D);
        glShadeModel	(GL_SMOOTH);
        glClearColor    ( 0,0,0, 0);
        glClear         (GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
        glColor3f(1,0,0);
        glBegin(GL_TRIANGLES);
                glColor3f(0 , 1 , 1); glVertex2f(0,0);
                glColor3f(1,  1,  0); glVertex2f(tx() , 0);
                glColor3f(1,  0,  0); glVertex2f(tx() , ty() );
        glEnd();
}

//*****************************************************************
//***  TSouris  ***************************************************
//*****************************************************************

void TSouris::Refresh()
{       //--- dplacement ---
        if (oldx!=-1) {oldx=x; oldy=y;}
        if (Nx  ==-1) {Nx=x; Ny=y;}
//        tagPOINT Pt;  GetCursorPos(&Pt); x=Pt.x; y=Pt.y;
        x=Nx;y=Ny;
        if (oldx==-1) {oldx=x; oldy=y;}

        //--- boutons ---
        if (ButtonL) MTime[M_LEFT ]++;  else MTime[M_LEFT ] =0;
        if (ButtonR) MTime[M_RIGHT]++;  else MTime[M_RIGHT] =0;
        if (ButtonM) MTime[M_MIDDLE]++; else MTime[M_MIDDLE]=0;
//        char LBut=GetKeyState(VK_LBUTTON);   if (LBut<0) MTime[M_LEFT ]++; else MTime[M_LEFT ]=0;
//        char RBut=GetKeyState(VK_RBUTTON);   if (RBut<0) MTime[M_RIGHT]++; else MTime[M_RIGHT]=0;
}
string TSouris::StrMouse()
{
    return( "x="+XS.IntToStr(x)+" y="+XS.IntToStr(y)+" ML="+XS.IntToStr(MTime[M_LEFT])+" MR="+XS.IntToStr(MTime[M_RIGHT]) );
}
string TSouris::StrOldMouse()
{
    return( "x(old)="+XS.IntToStr(x)+"("+XS.IntToStr(oldx)+")"+" y(old)="+XS.IntToStr(y)+"("+XS.IntToStr(oldy)+")" );
}

//*****************************************************************************
//**** float_time *************************************************************
//*****************************************************************************
// float_time Ess1 = float_time(2,500);          Exemple d'utilisation
// float_time Ess2 = 3;                          Exemple d'utilisation

float_time::float_time(float Ini,float duree1000,int Type0, float * Ptact, float modulo0) {
        ini=Ini; fin=Ini;
        duree=duree1000;
        Type=Type0;
        ptact=Ptact;
        modulo=modulo0;
}
void  float_time::operator =  (float Val) {
        ini=this->a();
        tini=*ptact;
        fin=Val;
}
float float_time::a() {
        if (duree<=0) return(fin);
        float f=(*ptact-tini)/duree;
        if (f<0) f=0;
        if (f>1) f=1;
        switch (Type)
        {
                case 1 : return ( ini + (fin-ini)*f*(1-f)*4 );
                case 2 : return ( ini + (fin-ini)* (sin(-PISD + PI*f)+1)/2.0 );
        }
        return ( fin*f + ini*(1-f) );
}
void float_time::Fixe(float f){fin=f; ini=f;}

