//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****      XDS SON  - MARS 2010 - CopyRight  XCS Corporation		    *****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                                  *****
//***************************************************************************
//***************************************************************************

#include "XCSSon.h"

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

TXMod           XMod;
TFSound         XSnd[NBMAXCHANNEL];
TFChannel       XChn[NBMAXCHANNEL];
FMOD_RESULT     ERR;


//---------------------------------------------------------------------------
void TXMod::LoadDigit  (string NomFich, int XDigit) {
        if (!Files.Exists(NomFich)) glSortirProprement (NomFich);
        ERR = FMOD_System_CreateSound( FSystem,  NomFich.c_str(),  FMOD_DEFAULT,  0,  &XSnd[XDigit].S );
        ERRCHECK(ERR);
}
//---------------------------------------------------------------------------
void TXMod::LoadStream (string NomFich, int XStream) {
        if (!Files.Exists(NomFich)) glSortirProprement (NomFich);
        ERR = FMOD_System_CreateSound( FSystem,  NomFich.c_str(),  FMOD_CREATESTREAM,  0,  &XSnd[XStream].S );          ERRCHECK(ERR);
        ERR = FMOD_System_PlaySound  ( FSystem , FMOD_CHANNEL_FREE ,XSnd[XStream].S ,false,&XChn[XStream].C );          ERRCHECK(ERR);
        XChn[XStream].Pause();
        XChn[XStream].SetVolume(VolDefaut);
}
//---------------------------------------------------------------------------
void TXMod::PlayStream  ( int XStream, int Deb_Snd, int Fin_Snd )
{
        XChn[XStream].SetPosMS(Deb_Snd);
        XChn[XStream].SetPaused(false);
        XChn[XStream].DebSnd = Deb_Snd;
        XChn[XStream].FinSnd = Fin_Snd;
}
//---------------------------------------------------------------------------
void TXMod::PlayDigit   ( int XDigit )
{
//    FMOD_System_PlaySound( FSystem ,   FMOD_CHANNEL_FREE , XSnd[XDigit].S , false , NULL); //&XChn[XDigit].C ); }
    FMOD_System_PlaySound( FSystem ,   FMOD_CHANNEL_REUSE , XSnd[XDigit].S , false , &XChn[XDigit].C );
}
//---------------------------------------------------------------------------
void TXMod::StopFondu   ( int XStream, int DureeMS )
{
        if (! XChn[XStream].isPlaying()) return;
        XChn [XStream].FinSnd      = XChn[XStream].GetPosMS() + DureeMS;
        XChn [XStream].DurFondu    = DureeMS;
}
//---------------------------------------------------------------------------
void TXMod::Refresh()
{
        TFChannel * C;

        for (int k=0; k<NBMAXCHANNEL; k++) {C=&XChn[k]; if (C->isPlaying())
        {
                int Pos = C->GetPosMS();

                //--- 1 --- Test de fondu
                if ( C->FinSnd && C->DurFondu && C->FinSnd-Pos<=C->DurFondu )
                C->SetVolume( ((float)C->FinSnd-Pos)/C->DurFondu );

                //--- 2 --- Test d'arrt
                if (C->FinSnd && Pos>=C->FinSnd)
                {
                        C->Pause();
                        C->DebSnd = C->FinSnd = C->DurFondu = 0;
                        C->SetVolume(VolDefaut);
                }


        }}

        //ERR=FMOD_System_Update(FSystem); // Ca plante quand un Stream se termine !! Quoi que tu fasses !!!
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void ERRCHECK   (FMOD_RESULT result) {
        if (result != FMOD_OK) glSortirProprement(FMOD_ErrorString(result));
}


