//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****      XCS SON  - MARS 2010 - CopyRight  XCS Corporation		    *****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                                  *****
//***************************************************************************
//***************************************************************************

#ifndef __XCSSON
#define __XCSSON

#include "XDSFree.h"
#include "fmod\\fmod.hpp"
#include "fmod\\fmod_errors.h"

#define NBMAXCHANNEL     500
/*
****************************************************************************
 Les Digits sont en FMOD_CHANNEL_FREE et n'ont PAS de channel associs :
   tu fais ton XMod.PlayDigit ( 20 ) et on n'en parle plus.
   tu contrles rien, car FMod n'est pas pratique :
   quand tu fais PlaySound ( FMOD_CHANNEL_FREE , &Channel )
   tu rcupres pas le Channel : c'est PAS vrai, et en plus a arrte le Channel prcdent !!?!!!
   a ne fait donc pas ce qui est crit dans la documentation.


 Un stream ne peut pas tre jou plusieurs fois simultanment
 Le numro du Channel correspond  celui du Stream
*****************************************************************************
*/

extern FMOD_RESULT ERR;
void ERRCHECK (FMOD_RESULT result);

//-----------------------------------------------------------------------------------------------------
class TFSound {public :
 FMOD_SOUND * S;
 string     GetName()           {char Nom[50]; if (!S) return(""); ERR=FMOD_Sound_GetName  (S,Nom,50);                  ERRCHECK(ERR); return(string(Nom));}
 int        GetLengthPCM()      {UINT L=69;    if (!S) return(0);  ERR=FMOD_Sound_GetLength(S,&L, FMOD_TIMEUNIT_PCM);   ERRCHECK(ERR); return(L);}
 int        GetLengthMS ()      {UINT L=69;    if (!S) return(0);  ERR=FMOD_Sound_GetLength(S,&L, FMOD_TIMEUNIT_MS);    ERRCHECK(ERR); return(L);}
 void       Release()           {              if (!S) return;     ERR=FMOD_Sound_Release  (S);                         ERRCHECK(ERR); S=0;}
 TFSound() {S=0;}
};
//-----------------------------------------------------------------------------------------------------
class TFChannel {public :
 int    GetPosMS ()             { UINT Pos=69;  if (!C) return(0); if (!isPlaying()) return(0);  ERR=FMOD_Channel_GetPosition ( C,&Pos,FMOD_TIMEUNIT_MS);ERRCHECK(ERR); return(Pos);     }
 void   SetPosMS (int Pos)      {               if (!C) return;    if (!isPlaying()) return;     ERR=FMOD_Channel_SetPosition ( C, Pos,FMOD_TIMEUNIT_MS);ERRCHECK(ERR);                  }

 FMOD_CHANNEL * C;
 void   Pause    ()             {SetPaused(true);}
 void   Stop     ()             {               if (!C) return;               ERR=FMOD_Channel_Stop        ( C );                     ERRCHECK(ERR); C=0;             }

 bool   GetPaused()             { int   Paus;   if (!C) return(0);            ERR=FMOD_Channel_GetPaused   ( C,&Paus);                ERRCHECK(ERR); return(Paus);    }
 void   SetPaused(bool Paus)    {               if (!C) return;               ERR=FMOD_Channel_SetPaused   ( C, Paus);                ERRCHECK(ERR);                  }

 void   SetFreq  (float Freq)   {               if (!C) return;               ERR=FMOD_Channel_SetFrequency( C,Freq );                ERRCHECK(ERR);                  }
 float  GetFreq  ()             { float f  =1;  if (!C) return(0);            ERR=FMOD_Channel_GetFrequency( C,&f );                  ERRCHECK(ERR); return(f);       }

 bool   isPlaying()             { int   b;      if (!C) return(false);        ERR=FMOD_Channel_IsPlaying   ( C,&b);                   ERRCHECK(ERR); return(b);       }
 void   SetVolume(float Vol01)  {               if (!C) return;               ERR=FMOD_Channel_SetVolume   ( C, Vol01);               ERRCHECK(ERR);                  }
 float  GetVolume()             { float Vol01;  if (!C) return(0);            ERR=FMOD_Channel_GetVolume   ( C,&Vol01);               ERRCHECK(ERR); return(Vol01);   }

 int DebSnd  ;
 int FinSnd  ;
 int DurFondu;

 TFChannel() {C=0;DebSnd=FinSnd=DurFondu=0;}
};
//-----------------------------------------------------------------------------------------------------

extern TFSound   XSnd[NBMAXCHANNEL];
extern TFChannel XChn[NBMAXCHANNEL];

class TXMod {   public :

        //------------------------- Digits --------------------------------------
        //------------------------- Digits --------------------------------------
        //------------------------- Digits --------------------------------------
        void LoadDigit   ( string NomFich, int XDigit );                         // 1) charge le XSnd en mmoire
        void PlayDigit   ( int XDigit );


        //------------------------- Stream --------------------------------------
        //------------------------- Stream --------------------------------------
        //------------------------- Stream --------------------------------------

        void LoadStream   ( string NomFich, int XStream );                         // 1) charge    2) joue et met sur Pause.
        void PlayStream   ( int XStream, int DebSnd, int FinSnd );               // voil.
        void PlayStream   ( int XStream ) {XChn[XStream].SetPaused(false);}
        void Stop         ( int XStream ) {XChn[XStream].SetPaused(true) ;}
        void StopFondu    ( int XStream, int DureeMS );

        int  GetPosStream    ( int XStream               ) {return(XChn[XStream].GetPosMS())    ; }
        void SetPosStream    ( int XStream, int PosMS    ) {       XChn[XStream].SetPosMS(PosMS); }
        void DecPosStream    ( int XStream, int DecaleMS ) {       XChn[XStream].SetPosMS( XChn[XStream].GetPosMS() + DecaleMS );  }
        int  GetLengthStream ( int XStream               ) {return(XSnd[XStream].GetLengthMS()) ; }

        float GetVolumeStream ( int XStream                 ) { return(XChn[XStream].GetVolume()); }
        void  SetVolumeStream ( int XStream, float    Vol01 ) {        XChn[XStream].SetVolume(Vol01); }
        void  DecVolumeStream ( int XStream, float DecVol01 ) {        XChn[XStream].SetVolume( XChn[XStream].GetVolume() + DecVol01 ); }

        void Refresh();                                                         //  appeler en boucle 1) Fondus 2) Fermer Streams

        TXMod()
        {
                FMOD_System_Create(&FSystem);
                ERR=FMOD_System_Init(FSystem,NBMAXCHANNEL,FMOD_INIT_NORMAL,0);    ERRCHECK(ERR);
                VolDefaut = 1;
        };

        //--- Variables techniques ---
        FMOD_SYSTEM  * FSystem;
        float VolDefaut; // Volume par dfaut, entre 0 et 1. Valeur initiale = 1

} extern XMod;


#endif
