//***************************************************************************
//***************************************************************************
//****                                                                  *****
//****      XMaths - JUIN 2011 - CopyRight  XC  Corporation		*****
//****                                                                  *****
//****                                     by Chauvet Xavier            *****
//****                                                                  *****
//***************************************************************************
//***************************************************************************

#ifndef XMathsH
#define XMathsH
#include "XDSFree.h"

#define ENRAD (3.1415926535f*2/360)
#define	EN360 (360/(3.1415926535f*2))
#define SGN(a) (a>=0?1:-1)
#define SQR(x)  ((x)*(x))
#define SQRT(a) ( (a==0?0:exp(0.5*log(a))) )
#define SQRC(a) ( exp(0.33333333333*log(a)) )
#define ChAprVir(a) ( (int)((a)*10) - ((int)(a)*10) )

//*******************************************************************************
//******   XTri   ***************************************************************
//*******************************************************************************

class TXTri {   public :
    void Tri_f      ( float * Nb_in , int Nb_f, float * Nb_out);                  //tri fusion
    void Tri_f_idx  ( float * Nb_in , int Nb_f,   int * IdxOut) {int * IdxIn=(int*)malloc(Nb_f*sizeof(int)); for (int k=0;k<Nb_f;k++)IdxIn[k]=k;Tri_f_idx(Nb_in,IdxIn,Nb_f,IdxOut);}
    void Classer    ( float * Nb_in , float * Out,int * IdxOut,int * Rang,int Nb);//tri bulle
    void Classer    (  int  * Nb_in , int   * Out,int * IdxOut,int * Rang,int Nb);//tri bulle

 private :
    void Tri_f_idx  ( float * Nb_in, int * IdxIn, int Nb_Idx, int * IdxOut) {Nb=Nb_in; Tri_f_idxrec(IdxIn,Nb_Idx,IdxOut);}
    void Tri_f_idxrec   (   int * IdxIn, int Nb_Idx, int * IdxOut);
    void Fusionne_f     ( float * L1   , int Nb1, float * L2   , int Nb2, float * L3);
    void Fusionne_f_Idx (   int * Idx1 , int Nb1,   int * Idx2 , int Nb2, int * Idx_out);
    float *Nb; // pour calcul Idx
} extern XTri;

//*****************************************************************************
//********* T2f T3f T2i *******************************************************
//*****************************************************************************

class  T3f {public :
    float x,y,z;
    T3f operator +  (const T3f& Pt) const;
    T3f operator -  (const T3f& Pt) const;
    T3f operator ^  (const T3f& Pt) const;
    T3f operator *  (const float Lambda) const;
    T3f (float x=0,float y=0,float z=0);
    float Norme();
    void Normalize();
    float Scal(T3f p);
    void LoadFromV(float * xyz) {x=xyz[0]; y=xyz[1]; z=xyz[2];}
    void Set(float xx,float yy,float zz) {x=xx; y=yy; z=zz;}
    string Str();
//    string Str() {return("x="+XS.FloatToStr2Ch(x)+" y="+XS.FloatToStr2Ch(y)+" z="+XS.FloatToStr2Ch(z));} // !!! Cette ligne peut TOUT FAIRE PLANTER !! Borland SHIT !!!
};
class T2f {public :
    float x,y;
    T2f operator +  (const T2f& Pt) const;
    T2f operator -  (const T2f& Pt) const;
    T2f operator ^  (const T2f& Pt) const;
    T2f operator *  (const float Lambda) const;
    T2f (float x=0,float y=0);
    void Set(float xx,float yy) {x=xx; y=yy;}
    float Norme();
    void Normalize();
    float Scal(T2f p);
//    string Str() {return("x="+XS.FloatToStr2Ch(x)+" y="+XS.FloatToStr2Ch(y));}  // !!! Cette ligne peut TOUT FAIRE PLANTER !!!
};
class  T2i {public :
        int x,y;
        T2i  operator +   (const T2i& Pt)    const;
        T2i  operator -   (const T2i& Pt)    const;
        T2i  operator *   (const int Lambda) const;
        bool operator ==  (const T2i& Pt)    const;
        T2i (int xx=0,int yy=0) {x=xx;y=yy;}
        int   Scal (T2i p);
        float ScalN(T2i p);
        int Dist2(T2i p);
        int SqrNorme();
        float Norme();
        void Rot90(); // Tourne le vecteur de 90 degrs....
};

struct TGeo {
        bool MemeCote (T2f A, T2f B, T2f C, T2f D); // renvoie : (A et B du mme ct de (CD))
        bool TriDirect(T2f A, T2f B, T2f C);
        bool Secant   (T2f A, T2f B, T2f C, T2f D); // renvoie : ([AB] inter [CD] != emptyset)

} extern Geo;

#endif
