#include "Nehe_freetype.h"

//*****************************************************************************
//*********** TTFont **********************************************************
//*****************************************************************************
inline int next_p2 ( int a ){	int rval=1;	while(rval<a) rval<<=1;	return rval;}   ///This function gets the first power of 2 >= the int that we pass it.

void TTFont::LoadFont_FT(string NomFich, int height)
{
	if (FT_Init_FreeType( &library ))                               throw std::runtime_error("FT_Init_FreeType failed");
	if (FT_New_Face( library, NomFich.c_str(), 0, &face ))	        throw std::runtime_error("FT_New_Face failed (there is probably a problem with your font file)");
	FT_Set_Char_Size( face, height << 6, height << 6, 96, 96);        // tailles de pixels * 64 car FreeFont compte en 1/64me de pixels
        FontChargee = true;
        Height=height;
    CreeTex_FT();
}
#define FT_MyData(x,y, TX,TY) data[3*(x+(TY-1 -y)*TX)]   = data[3*(x+(TY-1 -y)*TX)+1] = data[3*(x+(TY-1 -y)*TX)+2]
void TTFont::Export_AllLetters(string DebutFich)
{
        for (uchar ch=21; ch<255; ch++)
        {
                FT_Glyph glyph;
	        if(FT_Load_Glyph( face, FT_Get_Char_Index( face, ch ), FT_LOAD_DEFAULT )) throw runtime_error("FT_Load_Glyph failed");
                if(FT_Get_Glyph( face->glyph, &glyph ))              	                  throw runtime_error("FT_Get_Glyph failed");

	        FT_Glyph_To_Bitmap( &glyph, ft_render_mode_normal, 0, 1 );
                FT_BitmapGlyph bitmap_glyph     = (FT_BitmapGlyph)glyph;
	        FT_Bitmap& bitmap               = bitmap_glyph->bitmap;

	        GLubyte* data = new GLubyte[ 3 * bitmap.rows * bitmap.width];

                for(int j=0; j <bitmap.rows ; j++) for(int i=0; i <bitmap.width; i++)
                {
                          FT_MyData(i,j, bitmap.width,bitmap.rows) =  bitmap.buffer[i + bitmap.width*j];
                }

                string NomFich = DebutFich+XS.IntToStr(ch)+".bmp";
                // LOOOL if (bitmap.width) gl.SaveBMP(bitmap.width, bitmap.rows, NomFich,data);
                delete [] data;
        }
}
#define PushEnter(ss) {ss.push_back(13);ss.push_back(10);}
string GenereEnteteLigne(int kL, int yUp, int yAlign, int yDown)
{       string Rep="";
        for (int kk=0; kk<3; kk++) {Rep+="%%%%%%%%% LIGNE "+XS.IntToStr(kL)+" %%%%%%%%";PushEnter(Rep);}
        PushEnter(Rep);
        Rep+="yup    ="+XS.IntToStr(yUp);          PushEnter(Rep);
        Rep+="yalign ="+XS.IntToStr(yAlign);       PushEnter(Rep);
        Rep+="ydown  ="+XS.IntToStr(yDown);        PushEnter(Rep);PushEnter(Rep);
        return(Rep);
}
void TTFont::Export_glFonte(string NomFichNoExt, GLuint TXBMP)
{       GLubyte* data = new GLubyte[ 3 * 1024 * 1024];

        uint H = Height;
        int yalign = H*CoefMultEnter;
        int yup    = yalign;    int yupAct;
        int ydown  = yalign;    int ydownAct;
        int OfsX   = 1;

        string StrF; // Str File  crire
        string StrL; // Str LIGNE actuelle
        int kL=1;
        for (uchar * ch=(uchar*)Alphabet.c_str() ; *ch; ch++)
        {       //--- Lecture de la lettre
                FT_Glyph glyph;
	        if(FT_Load_Glyph( face, FT_Get_Char_Index( face, *ch ), FT_LOAD_DEFAULT )) throw runtime_error("FT_Load_Glyph failed");
                if(FT_Get_Glyph( face->glyph, &glyph ))              	                   throw runtime_error("FT_Get_Glyph failed");

	        FT_Glyph_To_Bitmap( &glyph, ft_render_mode_normal, 0, 1 );
                FT_BitmapGlyph bitmap_glyph     = (FT_BitmapGlyph)glyph;
	        FT_Bitmap& bitmap               = bitmap_glyph->bitmap;
                if (bitmap.rows==0 || bitmap.width==0) continue;

                //--- Saut de ligne ?
                if (OfsX + bitmap.width + 3 >=(int)TXBMP)
                {       if (kL>=2) PushEnter(StrF);
                        OfsX=1;
                        StrF+=GenereEnteteLigne( kL++,yup,yalign,ydown) + StrL;
                        yalign = ydown + H*CoefMultEnter;
                        yup     = ydown = yalign;
                        StrL="";
                        if (yup + H >=1024){goto BAM;}
                }

                //--- Ecriture de la lettre
                #define CCCC(x,y) CCC = 3* ( x + (y)*TXBMP )
                int i,j,CCC, AlignY;
                AlignY = bitmap_glyph->top;
                for(j=0; j <bitmap.rows ; j++)
                for(i=0; i <bitmap.width; i++)
                { uchar VAL = bitmap.buffer[i + bitmap.width*j];
                  CCCC(i+OfsX, j+yalign-AlignY); data[CCC]=data[CCC+1]=data[CCC+2] = VAL;
                }
                yupAct   = yalign-AlignY;               if (yupAct   < yup  ) yup   = yupAct;
                ydownAct = yalign-AlignY+bitmap.rows;   if (ydownAct > ydown) ydown = ydownAct;
//                CCCC(OfsX, yalign);     data[CCC]   = data[CCC+1]=255;   // cyan  = yAlign !!!!!!!!!!!
//                CCCC(OfsX, yupAct);     data[CCC+2] = 255;              // rouge = yUp    !!!!!!!!!!!
//                CCCC(OfsX, ydownAct);   data[CCC+1] = 255;           // vert  = yDown  !!!!!!!!!!!

//                char charFlo[100]; string strFlo;
                // LOOOOOOOOOOOLL  XS.FloatToStr2Ch(face->glyph->advance.x >>6, charFlo);     strFlo = charFlo;

                StrL.push_back(*ch); StrL+=" "+XS.IntToStr(OfsX)+" "+XS.IntToStr(OfsX+bitmap.width);
//                StrL = StrL + " "+strFlo;
                PushEnter(StrL);
                OfsX += bitmap.width+3;
        }

        BAM :
        //--- glFonte : BMP + TXT
//        int TYBMP_P2 = next_p2(ydown+1);

/*        TBMP B; B.New(TXBMP,1024,data);
        B.Cut(0,0,TXBMP,TYBMP_P2); B.Reverse();
        B.SaveBMP( NomFichNoExt+".bmp" );
        B.Free();
        if (kL>=2) PushEnter(StrF);
        StrF+=GenereEnteteLigne(kL++,yup,yalign,ydown) + StrL;
        TFilew F; F.Open(NomFichNoExt+".txt"); F.Wri_AS(StrF.c_str(),true); F.Close();
*/
        delete [] data;
}

//********************************************************* Bonus NEHE
//********************************************************* Bonus NEHE
//********************************************************* Bonus NEHE

float make_dlist ( FT_Face face,   char ch,   GLuint list_base,   GLuint * tex_base )
{   if (ch<=10) return(0);
    FT_Glyph glyph;
	if(FT_Load_Glyph( face, FT_Get_Char_Index( face, ch ), FT_LOAD_DEFAULT )) throw std::runtime_error("FT_Load_Glyph failed");
    if(FT_Get_Glyph ( face->glyph, &glyph )) 		                          throw std::runtime_error("FT_Get_Glyph failed");

	FT_Glyph_To_Bitmap( &glyph, ft_render_mode_normal, 0, 1 );
    FT_BitmapGlyph bitmap_glyph = (FT_BitmapGlyph)glyph;

	FT_Bitmap& bitmap=bitmap_glyph->bitmap;
	int width  = next_p2( bitmap.width );
	int height = next_p2( bitmap.rows  );
	GLubyte* expanded_data = new GLubyte[ 2 * width * height];

	for(int j=0; j < height; j++)
        for(int i=0; i <  width; i++)
        {
                  expanded_data[2*(i+j*width)]
                = expanded_data[2*(i+j*width)+1]
                =  (i>=bitmap.width || j>=bitmap.rows) ?   0   :   bitmap.buffer[i + bitmap.width*j];
	}

    glBindTexture( GL_TEXTURE_2D, tex_base[(uchar)ch] );
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
        glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA, width, height, 0, GL_LUMINANCE_ALPHA, GL_UNSIGNED_BYTE, expanded_data );
        delete [] expanded_data;

	glNewList(list_base+ch,GL_COMPILE);
	glBindTexture(GL_TEXTURE_2D,tex_base[(uchar)ch]);
        glTranslatef(bitmap_glyph->left,0,0);//first we need to move over a little so that the character has the right amount of space between it and the one before it.
	glPushMatrix();
        glTranslatef(0,bitmap_glyph->top - bitmap.rows,0);//Now we move down a little in the case that the bitmap extends past the bottom of the line (this is only true for characters like 'g' or 'y'.
	float	x=(float)bitmap.width / (float)width,
		y=(float)bitmap.rows  / (float)height;
	glBegin(GL_QUADS);
	glTexCoord2d(0,0); glVertex2f(0,bitmap.rows);
	glTexCoord2d(0,y); glVertex2f(0,0);
	glTexCoord2d(x,y); glVertex2f(bitmap.width,0);
	glTexCoord2d(x,0); glVertex2f(bitmap.width,bitmap.rows);
	glEnd();
	glPopMatrix();
	float TX_CHAR = face->glyph->advance.x >> 6;
	glTranslatef(TX_CHAR,0,0);

	//increment the raster position as if we were a bitmap font.
	//(only needed if you want to calculate text length)
	//glBitmap(0,0,0,0,face->glyph->advance.x >> 6,0,NULL);
	//Finish the display list
	glEndList();
	return(TX_CHAR);
}

float TTFont::TxTexte (string str, float size1 )
{
    float sum=0;
    for (uint k=0; k<str.length(); k++) sum+=txchar[(uchar)str[k]];
    return(sum*size1);
}
void TTFont::PrintCenter (float xC, float yC , string str, float size1 )
{
	float tx = TxTexte(str,size1);
	float ty = Height * size1;
    Print(xC-tx/2, yC-ty/2, str,size1);
}

void TTFont::CreeTex_FT ()
{
    TexChargees     = true;
	list_base       = glGenLists(255);
    textures        = new GLuint [255];
	glGenTextures ( 255, textures );
	for(unsigned char i=10;i<255;i++) txchar[i]=make_dlist(face,i,list_base,textures);
}
inline void pushScreenCoordinateMatrix() {
	glPushAttrib(GL_TRANSFORM_BIT);
	GLint	viewport[4];glGetIntegerv(GL_VIEWPORT, viewport);glMatrixMode(GL_PROJECTION);glPushMatrix();
	glLoadIdentity();gluOrtho2D(viewport[0],viewport[2],viewport[1],viewport[3]);glPopAttrib();
}
inline void pop_projection_matrix() {glPushAttrib(GL_TRANSFORM_BIT);glMatrixMode(GL_PROJECTION);glPopMatrix();glPopAttrib();}

void TTFont::Print(float x, float y, string str, float size1)
{
    pushScreenCoordinateMatrix();
    GLuint font  = list_base;

	glPushAttrib(GL_LIST_BIT | GL_CURRENT_BIT  | GL_ENABLE_BIT | GL_TRANSFORM_BIT);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();

	glDisable(GL_LIGHTING);	    glEnable(GL_TEXTURE_2D);
	glEnable(GL_ALPHA_TEST); 	glAlphaFunc(GL_GREATER, 0.0f);
    gl.EnableBlend();

	glListBase(font);

	float modelview_matrix[16];
	glScalef(size1,size1,1); //!!!!!! Pour changer la taille :)
	glGetFloatv(GL_MODELVIEW_MATRIX, modelview_matrix);

    glPushMatrix();
    glLoadIdentity();
    glTranslatef(x,y,0);
    glMultMatrixf(modelview_matrix);
    glCallLists(str.length(), GL_UNSIGNED_BYTE, str.c_str());
    glPopMatrix();

	glPopAttrib();
	pop_projection_matrix();
    glDisable(GL_BLEND);
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
}

